// Importerer ndvendige pakker
import gl4java.*;			// For  kunne implementere GLEnum og GLUEnum (gir tilgang til en rekke fields (variablene i store bokstaver))
import gl4java.utils.glut.*;	// Open GL's "verktyboks"

/**
 * <strong>Description:</strong><br>
 * A thin plate that just covers the opening of the bulbs, 
 * to be used togehter with bulbs, to make an hourglass.<br>
 * In the hourglass program it is only used for making a stand of glass
 * <br><strong>All code is extensively commented in Norwegian.</strong>
 * @author Therese Rsholdt, Grafisk Databehandling 2003, Hi
 * @version 0.1
 */
public class PlainStand extends Stand
{    
	//Variabler som er spesielle for denne subklassen
	float standThickness; // Tykkelsen p sttten
	
	/**
	* PlainStand constructor
	* @param gl the <code>GLFunc</code> interface that is used for this component
	* @param glu the <code>GLUFunc</code> interface that is used for this component
	* @param glut the <code>GLUTFunc</code> interface that is used for this component
	* @param bulbheight the height of the bulb, from the middle of the hourglass to the stand
	* @param endRadius the end radius of the bulb, used for setting the stands radius
	*/
	public PlainStand ( GLFunc gl, GLUFunc glu, GLUTFunc glut, float bulbheight, float endRadius ) 
	{
		super(gl, glu, bulbheight);
		standTypeName = "Plain";
		standThickness = endRadius / 20.0f;
		standRadius = endRadius;
	}
	
	/**
	* Draws a half hourglass stand
	* @param isLowerHalf used if the two halfs need to be different
	*/
	public void drawHalfStand(boolean isLowerHalf)
	{
		// I denne subklassen bruker jeg ikke gluQuadricOrientation som i de andre subklassene
		// fordi sttten skal vre av glass, og da skal materialet uansett vre p begge sider
		// En "plate" bestende av en disk og en sylinder
		gl.glPushMatrix();
		gl.glTranslatef(0.0f, 0.0f, innerHeight);
		glu.gluCylinder(standPart, standRadius, standRadius-0.05f, standThickness, 80, 1);
		gl.glTranslatef(0.0f, 0.0f, standThickness);
		glu.gluDisk(standPart, 0.0, standRadius-0.05f, 80, 1);
		gl.glPopMatrix();
	}
}