// Importerer ndvendige pakker
import gl4java.*;			// For  kunne implementere GLEnum og GLUEnum (gir tilgang til en rekke fields (variablene i store bokstaver))
import gl4java.utils.glut.*;	// Open GL's "verktyboks"

/**
 * <strong>Description:</strong><br>
 * A simple plate sticking out just a little further than the end opening of the bulbs,
 * to be used togehter with bulbs, to make an hourglass.<br>
 * <br><strong>All code is extensively commented in Norwegian.</strong>
 * @author Therese Rsholdt, Grafisk Databehandling 2003, Hi
 * @version 0.1
 */
public class SimpleStand extends Stand
{
	//Variabler som er spesielle for denne subklassen
	/** The thickness of the stand. */
	float standThickness;

	/**
	* SimpleStand constructor
	* @param gl the <code>GLFunc</code> interface that is used for this component
	* @param glu the <code>GLUFunc</code> interface that is used for this component
	* @param glut the <code>GLUTFunc</code> interface that is used for this component
	* @param bulbheight the height of the bulb, from the middle of the hourglass to the stand
	* @param endRadius the end radius of the bulb, used for setting the stands radius
	*/
	public SimpleStand ( GLFunc gl, GLUFunc glu, GLUTFunc glut, float bulbheight, float endRadius ) 
	{
		super(gl, glu, bulbheight);
		standTypeName = "Simple";
		standThickness = bulbheight / 20.0f;
		// Hvis sandbeholderen er "lukket i bunnen" (BizarreBulbs) er endRadius 0,
		// s verdien for standRadius kan da ikke vre avhengig av denne
		if(endRadius == 0.0f)
		{
			standRadius = bulbheight / 2.0f;
		}
		else
		{	
			standRadius = endRadius + standThickness;
		}
	}
	
	/**
	* Draws a half hourglass stand
	* @param isLowerHalf used if the two halfs need to be different
	*/
	public void drawHalfStand(boolean isLowerHalf)
	{		
		// En "plate" bestende av to "disker" og en sylinder
		gl.glPushMatrix();
		gl.glTranslatef(0.0f, 0.0f, innerHeight);
		glu.gluQuadricOrientation(standPart, GLU_INSIDE); //M snu disken nrmest glasset for  f materiale p rett side
		glu.gluDisk(standPart, 0.0, standRadius, 80, 1);
		glu.gluQuadricOrientation(standPart, GLU_OUTSIDE); // Sylinderen og siste disken skal ha default innside/utside   
		glu.gluCylinder(standPart, standRadius, standRadius, standThickness, 80, 1);
		gl.glTranslatef(0.0f, 0.0f, standThickness);
		glu.gluDisk(standPart, 0.0, standRadius, 80, 1);
		gl.glPopMatrix();
	}
}